rm -f hdlen.exe

g++ -O2        fast_hdlen.cpp -std=c++11 -o hdlen -Werror \
   -DINSTRUMENT \
   -g -Wall -Weffc++ -pedantic  \
   -pedantic-errors -Wextra -Waggregate-return -Wcast-align \
   -Wcast-qual  -Wchar-subscripts  -Wcomment -Wconversion \
   -Wdisabled-optimization \
   -Werror -Wfloat-equal  -Wformat  -Wformat=2 \
   -Wformat-nonliteral -Wformat-security  \
   -Wformat-y2k -Wimport  -Winit-self  -Winline -Winvalid-pch \
   -Wunsafe-loop-optimizations  -Wlong-long -Wmissing-braces \
   -Wmissing-field-initializers -Wmissing-format-attribute   \
   -Wmissing-include-dirs -Wmissing-noreturn \
   -Wpacked  -Wpadded -Wparentheses  -Wpointer-arith \
   -Wredundant-decls -Wreturn-type \
   -Wsequence-point  -Wshadow -Wsign-compare  -Wstack-protector \
   -Wstrict-aliasing -Wstrict-aliasing=2 -Wswitch  -Wswitch-default \
   -Wswitch-enum -Wtrigraphs  -Wuninitialized \
   -Wunknown-pragmas  -Wunreachable-code -Wunused \
   -Wunused-function  -Wunused-label  -Wunused-parameter \
   -Wunused-value  -Wunused-variable  -Wvariadic-macros \
   -Wvolatile-register-var  -Wwrite-strings   

if [ $? -ne 0 ] ; then exit ; fi
	
rm testresults/*.fast

echo ============================================================
echo Computing Optimized Version Results
./hdlen <testdata/4bits.txt >testresults/4bits.fast
diff  testresults/4bits.fast    testdata/4bits.gold
echo ........................................
./hdlen <testdata/5bits.txt >testresults/5bits.fast
diff  testresults/5bits.fast    testdata/5bits.gold
echo ........................................
./hdlen <testdata/6bits.txt >testresults/6bits.fast
diff  testresults/6bits.fast    testdata/6bits.gold
echo ........................................
./hdlen <testdata/7bits.txt >testresults/7bits.fast
diff  testresults/7bits.fast    testdata/7bits.gold
echo ........................................
./hdlen <testdata/8bits.txt >testresults/8bits.fast
diff  testresults/8bits.fast    testdata/8bits.gold
echo ........................................
./hdlen <testdata/9bits.txt >testresults/9bits.fast
diff  testresults/9bits.fast    testdata/9bits.gold
echo ........................................
./hdlen <testdata/10bits.txt >testresults/10bits.fast
diff  testresults/10bits.fast    testdata/10bits.gold
echo ........................................
./hdlen <testdata/11bits.txt >testresults/11bits.fast
diff  testresults/11bits.fast    testdata/11bits.gold
echo ........................................
./hdlen <testdata/12bits.txt >testresults/12bits.fast
diff  testresults/12bits.fast    testdata/12bits.gold
echo ........................................
./hdlen <testdata/13bits.txt >testresults/13bits.fast
diff  testresults/13bits.fast    testdata/13bits.gold
echo ........................................
./hdlen <testdata/14bits.txt >testresults/14bits.fast
diff  testresults/14bits.fast    testdata/14bits.gold
echo ........................................
./hdlen <testdata/15bits.txt >testresults/15bits.fast
diff  testresults/15bits.fast    testdata/15bits.gold
echo ........................................
./hdlen <testdata/16bits.txt >testresults/16bits.fast
diff  testresults/16bits.fast    testdata/16bits.gold
echo ........................................
./hdlen <testdata/17bits.txt >testresults/17bits.fast
diff  testresults/17bits.fast    testdata/17bits.gold
echo ........................................
./hdlen <testdata/18bits.txt >testresults/18bits.fast
diff  testresults/18bits.fast    testdata/18bits.gold
echo ........................................
./hdlen <testdata/19bits.txt >testresults/19bits.fast
diff  testresults/19bits.fast    testdata/19bits.gold
echo ........................................
./hdlen <testdata/20bits.txt >testresults/20bits.fast
diff  testresults/20bits.fast    testdata/20bits.gold
echo ........................................
./hdlen <testdata/21bits.txt >testresults/21bits.fast
diff  testresults/21bits.fast    testdata/21bits.gold
echo ........................................
./hdlen <testdata/22bits.txt >testresults/22bits.fast
diff  testresults/22bits.fast    testdata/22bits.gold
echo ........................................
./hdlen <testdata/23bits.txt >testresults/23bits.fast
diff  testresults/23bits.fast    testdata/23bits.gold
echo ........................................
./hdlen <testdata/24bits.txt >testresults/24bits.fast
diff  testresults/24bits.fast    testdata/24bits.gold
echo ........................................
./hdlen <testdata/32bits.txt >testresults/32bits.fast
diff  testresults/32bits.fast    testdata/32bits.gold
echo ........................................
./hdlen <testdata/40bits.txt >testresults/40bits.fast
diff  testresults/40bits.fast    testdata/40bits.gold
echo ........................................
./hdlen <testdata/64bits.txt >testresults/64bits.fast
diff  testresults/64bits.fast    testdata/64bits.gold
echo ........................................
./hdlen 5 8 <testdata/32bits.txt >testresults/32partial.fast
diff testresults/32partial.fast testdata/32partial.gold
echo ........................................
./hdlen 0x82608edb 3 3 >>testresults/other.fast
./hdlen 0x82608edb 4 4 >>testresults/other.fast
./hdlen 0x82608edb 5 5 >>testresults/other.fast
./hdlen 0x82608edb 6 6 >>testresults/other.fast
./hdlen 0x82608edb 7 7 >>testresults/other.fast
./hdlen 0x82608edb 8 8 >>testresults/other.fast
./hdlen 0x82608edb 3 4 >>testresults/other.fast
./hdlen 0x82608edb 4 5 >>testresults/other.fast
./hdlen 0x82608edb 5 7 >>testresults/other.fast
diff testresults/other.fast testdata/other.gold



echo ============================================================
echo Aggregated list of optimized code errors
diff testresults/4bits.fast testdata/4bits.gold
diff testresults/5bits.fast testdata/5bits.gold
diff testresults/6bits.fast testdata/6bits.gold
diff testresults/7bits.fast testdata/7bits.gold
diff testresults/8bits.fast testdata/8bits.gold
diff testresults/9bits.fast testdata/9bits.gold
diff testresults/10bits.fast testdata/10bits.gold
diff testresults/11bits.fast testdata/11bits.gold
diff testresults/12bits.fast testdata/12bits.gold
diff testresults/13bits.fast testdata/13bits.gold
diff testresults/14bits.fast testdata/14bits.gold
diff testresults/15bits.fast testdata/15bits.gold
diff testresults/16bits.fast testdata/16bits.gold
diff testresults/17bits.fast testdata/17bits.gold
diff testresults/18bits.fast testdata/18bits.gold
diff testresults/19bits.fast testdata/19bits.gold
diff testresults/20bits.fast testdata/20bits.gold
diff testresults/21bits.fast testdata/21bits.gold
diff testresults/22bits.fast testdata/22bits.gold
diff testresults/23bits.fast testdata/23bits.gold
diff testresults/24bits.fast testdata/24bits.gold
diff testresults/32bits.fast testdata/32bits.gold
diff testresults/40bits.fast testdata/40bits.gold
diff testresults/64bits.fast testdata/64bits.gold
diff testresults/32partial.fast testdata/32partial.gold
diff testresults/other.fast testdata/other.gold
echo ============================================================
echo TESTING COMPLETED!
echo ============================================================

g++ -O2        fast_hdlen.cpp -std=c++11 -o hdlen -Werror \
   -g -Wall -Weffc++ -pedantic  \
   -pedantic-errors -Wextra -Waggregate-return -Wcast-align \
   -Wcast-qual  -Wchar-subscripts  -Wcomment -Wconversion \
   -Wdisabled-optimization \
   -Werror -Wfloat-equal  -Wformat  -Wformat=2 \
   -Wformat-nonliteral -Wformat-security  \
   -Wformat-y2k -Wimport  -Winit-self  -Winline -Winvalid-pch \
   -Wunsafe-loop-optimizations  -Wlong-long -Wmissing-braces \
   -Wmissing-field-initializers -Wmissing-format-attribute   \
   -Wmissing-include-dirs -Wmissing-noreturn \
   -Wpacked  -Wpadded -Wparentheses  -Wpointer-arith \
   -Wredundant-decls -Wreturn-type \
   -Wsequence-point  -Wshadow -Wsign-compare  -Wstack-protector \
   -Wstrict-aliasing -Wstrict-aliasing=2 -Wswitch  -Wswitch-default \
   -Wswitch-enum -Wtrigraphs  -Wuninitialized \
   -Wunknown-pragmas  -Wunreachable-code -Wunused \
   -Wunused-function  -Wunused-label  -Wunused-parameter \
   -Wunused-value  -Wunused-variable  -Wvariadic-macros \
   -Wvolatile-register-var  -Wwrite-strings   

time ./hdlen 0x9d9947fd
   