rm -f slow_hdlen
g++ -O2        slow_hdlen.cpp -o slow_hdlen -std=c++11 -Werror \
   -DINSTRUMENT \
   -g -Wall -Weffc++ -pedantic  \
   -pedantic-errors -Wextra -Waggregate-return -Wcast-align \
   -Wcast-qual  -Wchar-subscripts  -Wcomment -Wconversion \
   -Wdisabled-optimization \
   -Werror -Wfloat-equal  -Wformat  -Wformat=2 \
   -Wformat-nonliteral -Wformat-security  \
   -Wformat-y2k -Wimport  -Winit-self  -Winline -Winvalid-pch \
   -Wunsafe-loop-optimizations  -Wlong-long -Wmissing-braces \
   -Wmissing-field-initializers -Wmissing-format-attribute   \
   -Wmissing-include-dirs -Wmissing-noreturn \
   -Wpacked  -Wpadded -Wparentheses  -Wpointer-arith \
   -Wredundant-decls -Wreturn-type \
   -Wsequence-point  -Wshadow -Wsign-compare  -Wstack-protector \
   -Wstrict-aliasing -Wstrict-aliasing=2 -Wswitch  -Wswitch-default \
   -Wswitch-enum -Wtrigraphs  -Wuninitialized \
   -Wunknown-pragmas  -Wunreachable-code -Wunused \
   -Wunused-function  -Wunused-label  -Wunused-parameter \
   -Wunused-value  -Wunused-variable  -Wvariadic-macros \
   -Wvolatile-register-var  -Wwrite-strings  
if [ $? -ne 0 ] ; then exit ; fi
   
rm -f testresults/*.slow
echo ============================================================
echo TEST Computing NON-optimized Version Results

# can un-comment more tests if you can wait for it to run longer

./slow_hdlen <testdata/4bits.txt >testresults/4bits.slow
diff  testresults/4bits.slow    testdata/4bits.gold

./slow_hdlen <testdata/5bits.txt >testresults/5bits.slow
diff  testresults/5bits.slow    testdata/5bits.gold

./slow_hdlen <testdata/6bits.txt >testresults/6bits.slow
diff  testresults/6bits.slow    testdata/6bits.gold

./slow_hdlen <testdata/7bits.txt >testresults/7bits.slow
diff  testresults/7bits.slow    testdata/7bits.gold

./slow_hdlen <testdata/8bits.txt >testresults/8bits.slow
diff  testresults/8bits.slow    testdata/8bits.gold

./slow_hdlen <testdata/9bits.txt >testresults/9bits.slow
diff  testresults/9bits.slow    testdata/9bits.gold

./slow_hdlen <testdata/10bits.txt >testresults/10bits.slow
diff  testresults/10bits.slow    testdata/10bits.gold

#./slow_hdlen <testdata/11bits.txt >testresults/11bits.slow
#diff  testresults/11bits.slow    testdata/11bits.gold

#./slow_hdlen <testdata/12bits.txt >testresults/12bits.slow
#diff  testresults/12bits.slow    testdata/12bits.gold

#./slow_hdlen <testdata/13bits.txt >testresults/13bits.slow
#diff  testresults/13bits.slow    testdata/13bits.gold

#./slow_hdlen <testdata/14bits.txt >testresults/14bits.slow
#diff  testresults/14bits.slow    testdata/14bits.gold

#./slow_hdlen <testdata/15bits.txt >testresults/15bits.slow
#diff  testresults/15bits.slow    testdata/15bits.gold

#./slow_hdlen <testdata/16bits.txt >testresults/16bits.slow
#diff  testresults/16bits.slow    testdata/16bits.gold

#./slow_hdlen <testdata/17bits.txt >testresults/17bits.slow
#diff  testresults/17bits.slow    testdata/17bits.gold

#./slow_hdlen <testdata/18bits.txt >testresults/18bits.slow
#diff  testresults/18bits.slow    testdata/18bits.gold

#./slow_hdlen <testdata/19bits.txt >testresults/19bits.slow
#diff  testresults/19bits.slow    testdata/19bits.gold

#./slow_hdlen <testdata/20bits.txt >testresults/20bits.slow
#diff  testresults/20bits.slow    testdata/20bits.gold

#./slow_hdlen <testdata/21bits.txt >testresults/21bits.slow
#diff  testresults/21bits.slow    testdata/21bits.gold

#./slow_hdlen <testdata/22bits.txt >testresults/22bits.slow
#diff  testresults/22bits.slow    testdata/22bits.gold

#./slow_hdlen <testdata/23bits.txt >testresults/23bits.slow
#diff  testresults/23bits.slow    testdata/23bits.gold

#./slow_hdlen <testdata/24bits.txt >testresults/24bits.slow
#diff  testresults/24bits.slow    testdata/24bits.gold

#./slow_hdlen <testdata/64bits.txt >testresults/64bits.slow
#diff  testresults/64bits.slow    testdata/64bits.gold


echo ============================================================
echo Aggregated list of slow code errors
diff testresults/4bits.slow testdata/4bits.gold
diff testresults/5bits.slow testdata/5bits.gold
diff testresults/6bits.slow testdata/6bits.gold
diff testresults/7bits.slow testdata/7bits.gold
diff testresults/8bits.slow testdata/8bits.gold
diff testresults/9bits.slow testdata/9bits.gold
diff testresults/10bits.slow testdata/10bits.gold
#diff testresults/11bits.slow testdata/11bits.gold
#diff testresults/12bits.slow testdata/12bits.gold
#diff testresults/13bits.slow testdata/13bits.gold
#diff testresults/14bits.slow testdata/14bits.gold
#diff testresults/15bits.slow testdata/15bits.gold
#diff testresults/16bits.slow testdata/16bits.gold
#diff testresults/17bits.slow testdata/17bits.gold
#diff testresults/18bits.slow testdata/18bits.gold
#diff testresults/19bits.slow testdata/19bits.gold
#diff testresults/20bits.slow testdata/20bits.gold
#diff testresults/21bits.slow testdata/21bits.gold
#diff testresults/22bits.slow testdata/22bits.gold
#diff testresults/23bits.slow testdata/23bits.gold
#diff testresults/24bits.slow testdata/24bits.gold
#diff testresults/64bits.slow testdata/64bits.gold
echo ============================================================
echo SLOW TESTING COMPLETED!
echo ============================================================

g++ -O2        slow_hdlen.cpp -o slow_hdlen -std=c++11 -Werror \
   -g -Wall -Weffc++ -pedantic  \
   -pedantic-errors -Wextra -Waggregate-return -Wcast-align \
   -Wcast-qual  -Wchar-subscripts  -Wcomment -Wconversion \
   -Wdisabled-optimization \
   -Werror -Wfloat-equal  -Wformat  -Wformat=2 \
   -Wformat-nonliteral -Wformat-security  \
   -Wformat-y2k -Wimport  -Winit-self  -Winline -Winvalid-pch \
   -Wunsafe-loop-optimizations  -Wlong-long -Wmissing-braces \
   -Wmissing-field-initializers -Wmissing-format-attribute   \
   -Wmissing-include-dirs -Wmissing-noreturn \
   -Wpacked  -Wpadded -Wparentheses  -Wpointer-arith \
   -Wredundant-decls -Wreturn-type \
   -Wsequence-point  -Wshadow -Wsign-compare  -Wstack-protector \
   -Wstrict-aliasing -Wstrict-aliasing=2 -Wswitch  -Wswitch-default \
   -Wswitch-enum -Wtrigraphs  -Wuninitialized \
   -Wunknown-pragmas  -Wunreachable-code -Wunused \
   -Wunused-function  -Wunused-label  -Wunused-parameter \
   -Wunused-value  -Wunused-variable  -Wvariadic-macros \
   -Wvolatile-register-var  -Wwrite-strings   
   